diff -pruN 5.5-3/debian/changelog 5.5-3ubuntu1/debian/changelog
--- 5.5-3/debian/changelog	2020-04-07 14:17:29.000000000 +0000
+++ 5.5-3ubuntu1/debian/changelog	2020-04-16 22:23:25.000000000 +0000
@@ -1,3 +1,13 @@
+strace (5.5-3ubuntu1) focal; urgency=medium
+
+  * Merge from Debian unstable.  Remaining changes:
+    - Apply ptrace-error-verbosity.patch
+    - also filter kexec_file_load out of the list of programs to run for other
+      tests.
+  * XFAIL multiple tests with CPU timeout to fix FTBFS on riscv64
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Fri, 17 Apr 2020 00:23:25 +0200
+
 strace (5.5-3) unstable; urgency=medium
 
   * Take more upstream patches to fix mipsel test failures
@@ -20,6 +30,33 @@ strace (5.5-1) unstable; urgency=medium
 
  -- Steve McIntyre <93sam@debian.org>  Thu, 26 Mar 2020 10:30:07 +0100
 
+strace (4.26-0.2ubuntu3) eoan; urgency=medium
+
+  * also filter kexec_file_load out of the list of programs to run for other
+    tests.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 03 May 2019 05:19:49 +0000
+
+strace (4.26-0.2ubuntu2) eoan; urgency=medium
+
+  * debian/patches/kexec_file_load.patch: reintroduce now for arm64, which
+    has added the syscall only in Linux 5.0 and later, so has the same
+    problem as before with the split between kernel build headers and
+    runtime kernel.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 02 May 2019 17:55:57 -0700
+
+strace (4.26-0.2ubuntu1) eoan; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - Apply ptrace-error-verbosity.patch
+  * Drop kexec_file_load.patch; was already disabled in previous
+    versions, and causes no problems since we are consistently building/
+    testing devel against a much newer kernel than 4.11.
+  * Drop fix-glibc-ftbfs.patch, fixed differently upstream.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 02 May 2019 16:50:08 -0700
+
 strace (4.26-0.2) unstable; urgency=medium
 
   * Non-maintainer upload.
@@ -42,6 +79,26 @@ strace (4.26-0.1) unstable; urgency=medi
 
  -- Andreas Henriksson <andreas@fatal.se>  Sat, 12 Jan 2019 20:32:27 +0100
 
+strace (4.25-0ubuntu1) disco; urgency=medium
+
+  * New upstream version.
+
+ -- Matthias Klose <doko@ubuntu.com>  Sat, 24 Nov 2018 14:27:33 +0100
+
+strace (4.21-1ubuntu2) cosmic; urgency=medium
+
+  * Fix ftbfs with new glibc, statx is now defined.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 04 Oct 2018 17:03:56 +0100
+
+strace (4.21-1ubuntu1) bionic; urgency=medium
+
+  * Merge with Debian; remaining changes:
+    - Apply ptrace-error-verbosity.patch
+    - kexec_file_load.patch: Skip kexec_file_load test on ppc* before 4.11.
+
+ -- Matthias Klose <doko@ubuntu.com>  Wed, 11 Apr 2018 16:18:47 +0200
+
 strace (4.21-1) unstable; urgency=medium
 
   * New upstream release(s)
@@ -74,6 +131,24 @@ strace (4.21-1) unstable; urgency=medium
 
  -- Steve McIntyre <93sam@debian.org>  Mon, 19 Feb 2018 14:59:09 +0000
 
+strace (4.19-1ubuntu2) bionic; urgency=medium
+
+  * debian/patches/tests-fix-llseek-test.patch: Cherry pick upstream commit
+    3d2a5884ce6311834ae16729e2b01ccf3625c6dd to fix llseek test on armhf
+
+ -- Julian Andres Klode <juliank@ubuntu.com>  Tue, 23 Jan 2018 12:53:51 +0100
+
+strace (4.19-1ubuntu1) bionic; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - Apply ptrace-error-verbosity.patch
+    - debian/patches/no-arm-unaligned-access: Don't allow unaligned access
+      on ARM in the tests.
+    - kexec_file_load.patch: Skip kexec_file_load test on ppc* before 4.11.
+    - debian/control: Use linux-any for architecture fields
+
+ -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 12 Jan 2018 18:21:49 +0100
+
 strace (4.19-1) unstable; urgency=medium
 
   * New upstream release(s)
@@ -82,6 +157,26 @@ strace (4.19-1) unstable; urgency=medium
 
  -- Steve McIntyre <93sam@debian.org>  Wed, 01 Nov 2017 02:29:18 +0000
 
+strace (4.15-2ubuntu3) artful; urgency=medium
+
+  * kexec_file_load.patch: Skip kexec_file_load test on ppc* before 4.11.
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Sat, 17 Jun 2017 11:12:39 -0600
+
+strace (4.15-2ubuntu2) artful; urgency=medium
+
+  * debian/patches/no-arm-unaligned-access: Don't allow unaligned access
+    on ARM in the tests.
+
+ -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 15 Jun 2017 21:57:41 -0700
+
+strace (4.15-2ubuntu1) zesty; urgency=low
+
+  * Merge from Debian unstable.  Remaining changes:
+    - Apply ptrace-error-verbosity.patch
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 19 Jan 2017 14:02:00 +0000
+
 strace (4.15-2) unstable; urgency=medium
 
   * Disable some tests on hppa too
@@ -128,6 +223,15 @@ strace (4.13-1) unstable; urgency=medium
 
  -- Dmitry V. Levin <ldv@altlinux.org>  Tue, 26 Jul 2016 16:17:18 +0000
 
+strace (4.12-3ubuntu1) yakkety; urgency=medium
+
+  * Merge from Debian unstalbe.  Remaining changes:
+    - Apply ptrace-error-verbosity.patch
+
+  * Drop lseek patch, no longer needed.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 12 Aug 2016 11:08:03 +0100
+
 strace (4.12-3) unstable; urgency=medium
 
   * Fix up 32/64-bit test output in strace -S test to fix i386 build
@@ -154,6 +258,19 @@ strace (4.12-1) unstable; urgency=low
 
  -- Steve McIntyre <93sam@debian.org>  Fri, 03 Jun 2016 00:18:40 +0100
 
+strace (4.11-1ubuntu3) xenial; urgency=high
+
+  * Patch lseek test-suite to ignore libc generated lseek calls.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 13 Jan 2016 14:51:01 +0000
+
+strace (4.11-1ubuntu2) xenial; urgency=high
+
+  * Merge from Debian unstable.  Remaining changes:
+    - Apply ptrace-error-verbosity.patch    
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 12 Jan 2016 16:03:48 +0000
+
 strace (4.11-1) unstable; urgency=low
 
   [ Dmitry V. Levin ]
@@ -167,6 +284,17 @@ strace (4.11-1) unstable; urgency=low
 
  -- Steve McIntyre <93sam@debian.org>  Fri, 08 Jan 2015 00:52:05 +0000
 
+strace (4.10-3ubuntu1) xenial; urgency=high
+
+  * Merge from Debian, remaining changes are:
+    - Apply ptrace-error-verbosity.patch
+    - Set architectures to linux-any
+  * New upstream release:
+    - Remaining patches dropped
+    - Autoreconf changes dropped
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 14 Dec 2015 13:46:13 +0000
+
 strace (4.10-3) unstable; urgency=medium
 
   * Really fix mips* builds - fix sys_syscall() handling.
@@ -1015,7 +1143,6 @@ strace (3.1-3) unstable; urgency=low
 
  -- Wichert Akkerman <wakkerma@wi.leidenuniv.nl>  Thu, 11 Jul 1996 20:19:11 +0200
 
-
 strace (3.1-2) unstable; urgency=low
 
   * Added some #ifdef's around IPX stuff to make it compilable on non-Linux
@@ -1038,3 +1165,4 @@ strace (3.1-1) unstable; urgency=low
   * added IPX support
 
  -- Wichert Akkerman <wakkerma@wi.leidenuniv.nl>  Thu, 1 Jun 1996 00:00:00 +0000
+
diff -pruN 5.5-3/debian/control 5.5-3ubuntu1/debian/control
--- 5.5-3/debian/control	2020-04-07 14:17:29.000000000 +0000
+++ 5.5-3ubuntu1/debian/control	2020-04-16 22:23:25.000000000 +0000
@@ -1,5 +1,6 @@
 Source: strace
-Maintainer: Steve McIntyre <93sam@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Steve McIntyre <93sam@debian.org>
 Section: utils
 Priority: optional
 Build-Depends: libc6-dev (>= 2.2.2) [!alpha !ia64], libc6.1-dev (>= 2.2.2) [alpha ia64], gcc-multilib [amd64 i386 powerpc ppc64 s390 sparc sparc64 x32], debhelper (>= 10.0.0), gawk, libunwind-dev [amd64], libiberty-dev [amd64], libbluetooth-dev
diff -pruN 5.5-3/debian/patches/0005-XFAIL-multiple-wrong-or-failing-tests-to-fix-FTBFS.patch 5.5-3ubuntu1/debian/patches/0005-XFAIL-multiple-wrong-or-failing-tests-to-fix-FTBFS.patch
--- 5.5-3/debian/patches/0005-XFAIL-multiple-wrong-or-failing-tests-to-fix-FTBFS.patch	1970-01-01 00:00:00.000000000 +0000
+++ 5.5-3ubuntu1/debian/patches/0005-XFAIL-multiple-wrong-or-failing-tests-to-fix-FTBFS.patch	2020-04-16 22:23:25.000000000 +0000
@@ -0,0 +1,73 @@
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Wed, 15 Apr 2020 23:06:23 +0200
+Subject: XFAIL multiple wrong or failing tests to fix FTBFS
+
+---
+ tests/Makefile.am | 20 ++++++++++++++++++++
+ tests/Makefile.in | 22 +++++++++++++++++++++-
+ 2 files changed, 41 insertions(+), 1 deletion(-)
+
+diff --git a/tests/Makefile.am b/tests/Makefile.am
+index 6d70fa7..1a37ad6 100644
+--- a/tests/Makefile.am
++++ b/tests/Makefile.am
+@@ -392,6 +392,26 @@ MISC_TESTS = \
+ 
+ TESTS = $(GEN_TESTS) $(DECODER_TESTS) $(MISC_TESTS) $(STACKTRACE_TESTS)
+ 
++# failing for CPU time limit exceeded
++XFAIL_TESTS_riscv64 = clock.gen.test \
++	filtering_syscall-syntax.test \
++	printpath-umovestr.gen.test \
++	qual_fault-syscall.test \
++	qual_fault.test \
++	regex.gen.test \
++	sched.gen.test \
++	trace_creds.gen.test \
++	trace_fstatfs.gen.test \
++	trace_fstat.gen.test \
++	trace_lstat.gen.test \
++	trace_personality_64.gen.test \
++	trace_personality_regex_64.gen.test \
++	trace_question.gen.test \
++	trace_statfs.gen.test \
++	trace_statfs_like.gen.test \
++	trace_stat.gen.test \
++	trace_stat_like.gen.test
++
+ XFAIL_TESTS_ =
+ XFAIL_TESTS_m32 = $(STACKTRACE_TESTS)
+ XFAIL_TESTS_mx32 = $(STACKTRACE_TESTS)
+diff --git a/tests/Makefile.in b/tests/Makefile.in
+index 783230e..95e9a21 100644
+--- a/tests/Makefile.in
++++ b/tests/Makefile.in
+@@ -5512,7 +5512,27 @@ MISC_TESTS = \
+ 	umovestr_cached.test \
+ 	# end of MISC_TESTS
+ 
+-XFAIL_TESTS_ = 
++# failing for CPU time limit exceeded
++XFAIL_TESTS_riscv64 = clock.gen.test \
++	filtering_syscall-syntax.test \
++	printpath-umovestr.gen.test \
++	qual_fault-syscall.test \
++	qual_fault.test \
++	regex.gen.test \
++	sched.gen.test \
++	trace_creds.gen.test \
++	trace_fstatfs.gen.test \
++	trace_fstat.gen.test \
++	trace_lstat.gen.test \
++	trace_personality_64.gen.test \
++	trace_personality_regex_64.gen.test \
++	trace_question.gen.test \
++	trace_statfs.gen.test \
++	trace_statfs_like.gen.test \
++	trace_stat.gen.test \
++	trace_stat_like.gen.test
++
++XFAIL_TESTS_ =
+ XFAIL_TESTS_m32 = $(STACKTRACE_TESTS)
+ XFAIL_TESTS_mx32 = $(STACKTRACE_TESTS)
+ XFAIL_TESTS = $(XFAIL_TESTS_$(MPERS_NAME)) $(XFAIL_TESTS_$(ARCH))
diff -pruN 5.5-3/debian/patches/kexec_file_load.patch 5.5-3ubuntu1/debian/patches/kexec_file_load.patch
--- 5.5-3/debian/patches/kexec_file_load.patch	1970-01-01 00:00:00.000000000 +0000
+++ 5.5-3ubuntu1/debian/patches/kexec_file_load.patch	2020-04-16 22:23:25.000000000 +0000
@@ -0,0 +1,26 @@
+From: Adam Conrad <adconrad@ubuntu.com>
+Date: Thu, 16 Apr 2020 17:35:45 +0200
+Subject: Skip kexec_file_load test on arm64 before 5.0.
+
+Last-Update: 2019-05-02
+---
+ tests/kexec_file_load.gen.test | 8 ++++++++
+ 1 file changed, 8 insertions(+)
+
+diff --git a/tests/kexec_file_load.gen.test b/tests/kexec_file_load.gen.test
+index 1101349..682b076 100755
+--- a/tests/kexec_file_load.gen.test
++++ b/tests/kexec_file_load.gen.test
+@@ -1,4 +1,12 @@
+ #!/bin/sh -efu
+ # Generated by ./tests/gen_tests.sh from ./tests/gen_tests.in (kexec_file_load -s9 ); do not edit.
+ . "${srcdir=.}/init.sh"
++
++case $(uname -m) in
++  aarch64*)
++    # kexec_file_load was wired up after 4.18.x
++    require_min_kernel_version_or_skip 5.0
++    ;;
++esac
++
+ run_strace_match_diff -s9 
diff -pruN 5.5-3/debian/patches/ptrace-error-verbosity.patch 5.5-3ubuntu1/debian/patches/ptrace-error-verbosity.patch
--- 5.5-3/debian/patches/ptrace-error-verbosity.patch	1970-01-01 00:00:00.000000000 +0000
+++ 5.5-3ubuntu1/debian/patches/ptrace-error-verbosity.patch	2020-04-16 22:23:25.000000000 +0000
@@ -0,0 +1,31 @@
+From: Kees Cook <kees@ubuntu.com>
+Date: Thu, 16 Apr 2020 17:35:45 +0200
+Subject: try to make the PTRACE scope sysctl more discoverable via a
+
+verbose error message when failures happen.
+---
+ strace.c | 4 ++++
+ 1 file changed, 4 insertions(+)
+
+diff --git a/strace.c b/strace.c
+index e8bbf0e..bd14e83 100644
+--- a/strace.c
++++ b/strace.c
+@@ -1118,6 +1118,8 @@ static void
+ attach_tcb(struct tcb *const tcp)
+ {
+ 	if (ptrace_attach_or_seize(tcp->pid) < 0) {
++		if (errno == EPERM)
++			perror_msg("Could not attach to process. If your uid matches the uid of the target process, check the setting of /proc/sys/kernel/yama/ptrace_scope, or try again as the root user. For more details, see /etc/sysctl.d/10-ptrace.conf");
+ 		perror_msg("attach: ptrace(%s, %d)",
+ 			   ptrace_attach_cmd, tcp->pid);
+ 		droptcb(tcp);
+@@ -1147,6 +1149,8 @@ attach_tcb(struct tcb *const tcp)
+ 
+ 			++ntid;
+ 			if (ptrace_attach_or_seize(tid) < 0) {
++				if (errno == EPERM)
++					perror_msg("Could not attach to process. If your uid matches the uid of the target process, check the setting of /proc/sys/kernel/yama/ptrace_scope, or try again as the root user. For more details, see /etc/sysctl.d/10-ptrace.conf");
+ 				++nerr;
+ 				debug_perror_msg("attach: ptrace(%s, %d)",
+ 						 ptrace_attach_cmd, tid);
diff -pruN 5.5-3/debian/patches/series 5.5-3ubuntu1/debian/patches/series
--- 5.5-3/debian/patches/series	2020-04-07 14:17:29.000000000 +0000
+++ 5.5-3ubuntu1/debian/patches/series	2020-04-16 22:23:25.000000000 +0000
@@ -4,3 +4,6 @@ no-arm-unaligned-access
 03-disable_mips_umovestr_cached
 04-fix_mips_getuid_tests
 05-fixup_mips_creds_tests
+ptrace-error-verbosity.patch
+kexec_file_load.patch
+0005-XFAIL-multiple-wrong-or-failing-tests-to-fix-FTBFS.patch
diff -pruN 5.5-3/debian/rules 5.5-3ubuntu1/debian/rules
--- 5.5-3/debian/rules	2020-04-07 14:17:29.000000000 +0000
+++ 5.5-3ubuntu1/debian/rules	2020-04-16 22:23:25.000000000 +0000
@@ -49,6 +49,10 @@ configure:
 %-stamp: %/Makefile
 	$(MAKE) -C $*
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
+ifeq ($(DEB_HOST_ARCH),arm64)
+	# kexec_file_load only implemented on kernel >= 5.0
+	sed -i -e'/kexec_file_load/ s/^#*/#/' tests/pure_executables.list
+endif
 	$*/strace -V
 	$(MAKE) -C $* check VERBOSE=1
 endif
@@ -71,6 +75,7 @@ clean:
 	dh_testdir
 	dh_testroot
 	rm -rf build build-udeb build64 strace64.1 debian/strace64.substvars
+	sed -i -e'/kexec_file_load/ s/^#*//' tests/pure_executables.list
 	dh_clean
 
 binary: binary-indep binary-arch
